<?php

// This script is intended to manage specific source code mods for the TNG package software.
//  
// Customizations:
//   - extended mod filenames to allow up to 70 characters - Ken Roy
// 
global $prevtime;

$mod_manager_ver = "2.0";
$mod_manager_date = "May 18, 2009";
$path = "./mod_folder/";
$extension = "cfg";

// Brian McFadyen
// Distribution of the latest version of this package may be found at
// genwiki.mcfadyen.ca/TNG_mods
// For further details, contact   genealogy@mcfadyen.ca
//

include("../subroot.php");
include($subroot . "config.php");
include("adminlib.php");
include("adminlog.php");
$textpart = "setup";
include("../getlang.php");
include("../$mylanguage/admintext.php");
tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;
include("checklogin.php");
include("../version.php");


if( !$sub ) $sub = "tables";
$flags[tabs] = $tngconfig[tabs];
tng_adminheader( "Mod Manager", $flags );

$remove_mod = "";
$remove_mod_confirmed = "";
$clean_mod = "";
$clean_mod_confirmed = "";
$install_mod = "";
$install_mod_confirmed = "";
$edit_mod = "";
$edit_mod_confirmed = "";
$read_edit_values = "";
$delete_cfg = "";
$delete_cfg_confirmed = "";

if(isset($_POST[remove_mod])) $remove_mod = $_POST[remove_mod];
if(isset($_POST[remove_mod_confirmed])) $remove_mod_confirmed = $_POST[remove_mod_confirmed];
if(isset($_POST[clean_mod])) $clean_mod = $_POST[clean_mod];
if(isset($_POST[clean_mod_confirmed])) $clean_mod_confirmed = $_POST[clean_mod_confirmed];
if(isset($_POST[install_mod])) 	$install_mod = $_POST[install_mod];
if(isset($_POST[install_mod_confirmed])) $install_mod_confirmed = $_POST[install_mod_confirmed];
if(isset($_POST[edit_mod])) $edit_mod = $_POST[edit_mod];
if(isset($_POST[edit_mod_confirmed])) $edit_mod_confirmed = $_POST[edit_mod_confirmed];
if(isset($_POST[read_edit_values])) $read_edit_values = $_POST[read_edit_values];
if(isset($_POST[delete_cfg])) $delete_cfg = $_POST[delete_cfg];
if(isset($_POST[delete_cfg_confirmed])) $delete_cfg_confirmed = $_POST[delete_cfg_confirmed];
?>


<style type="text/css">
td.avail{
	border-bottom:2px solid #00FF99;
	border-right:2px solid #00FF99;
	border-top:1px solid #00FF33;
	border-left:1px solid #00FF33;
	background-color:#FFFFFF;
	text-align: center;
}
td.inst{
	border-bottom:2px solid #00FF99;
	border-right:2px solid #00FF99;
	border-top:1px solid #00FF33;
	border-left:1px solid #00FF33;
	background-color:#CCFFCC;
	text-align: center;
}
td.failed{
	border-bottom:2px solid #660000;
	border-right:2px solid #660000;
	border-top:1px solid #CC0000;
	border-left:1px solid #CC0000;
	background-color:#FFCCCC;
	text-align: center;
}
form {
	margin: 0;
}
.header i{
	font-size: 12px;
}
</style>
<script type="text/javascript" src="admin.js"></script>
</head>

<body background="../background.gif">

<?php
	$modtabs[0] = array(1,"manage_mods.php","Mod List","listmods");
	$innermenu = "<a href=\"javascript:newwindow=window.open('http://genwiki.mcfadyen.ca/index.php/TNG_Mod_Manager', 'newwindow', 'height=500,width=700,resizable=yes,scrollbars=yes'); newwindow.focus();\" class=\"lightlink\">$admtext[help]</a>";
	$menu = doMenu($modtabs,"listmods",$innermenu);
	echo displayHeadline("Mod Manager","setup_icon.gif",$menu,$message);
	$first_menu=TRUE;
?>

<table width="100%" border="0" cellpadding="10" cellspacing="2" class="lightback">
<tr class="databack">
<td class="tngshadow">
	<div class="normal">
		<br><p><b>TNG Mod Management - Release V<?php echo $mod_manager_ver;?></b>
		<br>This Mod Manager is designed to manage mods coded for use with this Manager.
		<br><i>For support, check the <a href="http://genwiki.mcfadyen.ca/index.php/TNG_Mod_Manager">distribution site</a>, release date <?php echo $mod_manager_date;?></i></p>


<?php
//-------------------------------------------------------------------------
// REMOVE MOD (Confirmation Request)
if($remove_mod != ""){
	$first_menu=FALSE;
?>
		<br>
Request to remove TNG mod <?php echo $remove_mod;?>.<br>
Confirm request or cancel<br><br>
		<table><tr>
			<td>
				<form action="<?php echo $PHP_SELF; ?>" method="POST">
					<input type="hidden" name="remove_mod_confirmed" value="<?php echo $remove_mod; ?>">
					<input type="submit" value="Confirm Remove">
				</form>
			</td>
			<td>
				<form action="<?php echo $PHP_SELF; ?>" method="POST">
					<input type="hidden" name="cancel" value="none">
					<input type="submit" value="Cancel">
				</form>
			</td>
		</tr></table>
<?php
}

//--------------------------------------------------------------------------
// REMOVE MOD (Confirmed)
if($remove_mod_confirmed != ""){
	$first_menu=FALSE;
	echo "<br>Confirmed request to remove TNG mod $remove_mod_confirmed.<br>";
	$mod_status = mod_remove($rootpath,"$path$remove_mod_confirmed");
	if($mod_status == "removed"){
		echo "<br><br>$remove_mod_confirmed Removed<br>";
	}else{
		echo "<br><br><b>$remove_mod_confirmed Not Removed due to the following errors:</b><br>";
		echo "$mod_status<br>";
	}
?>
		<form action="<?php echo $PHP_SELF; ?>" method="POST">
			<input type="hidden" name="cancel" value="none">
			<input type="submit" value="Return to Status">
		</form>
<?php
}

//---------------------------------------------------------------------------
// CLEAN MOD (Confirmation Request)
if($clean_mod != ""){
	$first_menu=FALSE;
?>
		<br>
Request to clean TNG mod <?php echo $clean_mod;?>.<br>
Confirm request or cancel<br><br>
		<table><tr>
			<td>
				<form action="<?php echo $PHP_SELF; ?>" method="POST">
					<input type="hidden" name="clean_mod_confirmed" value="<?php echo $clean_mod; ?>">
					<input type="submit" value="Confirm Clean">
				</form>
			</td>
			<td>
				<form action="<?php echo $PHP_SELF; ?>" method="POST">
					<input type="hidden" name="cancel" value="none">
					<input type="submit" value="Cancel">
				</form>
			</td>
		</tr></table>
<?php
}

//----------------------------------------------------------------------------
// CLEAN MOD (Confirmed)
if($clean_mod_confirmed != ""){
	$first_menu=FALSE;
	echo "<br>Confirmed request to clean TNG mod $clean_mod_confirmed.<br>";
	$mod_status = mod_remove($rootpath,"$path$clean_mod_confirmed");
	if($mod_status == "removed"){
		echo "<br><br>$clean_mod_confirmed Clean attempted<br>";
	}else{
		echo "<br><br><b>$clean_mod_confirmed Cleanup performed with following notes:</b><br>";
		echo "$mod_status<br>";
	}
	?>
		<form action="<?php echo $PHP_SELF; ?>" method="POST">
			<input type="hidden" name="cancel" value="none">
			<input type="submit" value="Return to Status">
		</form>
<?php
}

//---------------------------------------------------------------------------
// EDIT MOD (Confirmation Request and Parameter Request and Read Edit Values)
if($edit_mod != ""){
	$first_menu=FALSE;
?>
		<br>
Request to edit TNG mod <?php echo $edit_mod;?>.<br>
Confirm request or cancel<br><br>
		<table><tr>
			<td>
				<form action="<?php echo $PHP_SELF; ?>" method="POST">
<?php
		if($read_edit_values != ""){
			mod_read_edit($rootpath,$path,$edit_mod);
		}
		echo mod_edit($rootpath,$path,$edit_mod);
?>
					<input type="hidden" name="edit_mod_confirmed" value="<?php echo $edit_mod; ?>">
					<input type="submit" value="Confirm Edit">
				</form>
			</td>
			<tr>
				<td>
					<form action="<?php echo $PHP_SELF; ?>" method="POST">
						<input type="hidden" name="cancel" value="none">
						<input type="submit" value="Cancel">
					</form>
				</td>
			</tr>
			<tr>
				<td>
					<form action="<?php echo $PHP_SELF; ?>" method="POST">
						<input type="hidden" name="edit_mod" value="<?php echo $edit_mod; ?>">
						<input type="hidden" name="read_edit_values" value="<?php echo $edit_mod; ?>">
						<input type="submit" value="Read Existing Values from TNG files">
					</form>
				</td>
			</tr>
<?php
		if($read_edit_values != ""){
			echo "<tr><td><br>Configuration Values Read from TNG files.</td></tr>";
		}
?>
		</tr></table>
<?php
}

//---------------------------------------------------------------------------
// EDIT MOD (Confirmed)
if($edit_mod_confirmed != ""){
	$first_menu=FALSE;
	echo "<br>Confirmed request to update TNG mod with Values $edit_mod_confirmed.<br>";
	$mod_status = mod_edit_action($rootpath,"$path$edit_mod_confirmed",$_POST);
	if($mod_status == "done"){
		echo "<br><br>$edit_mod_confirmed Edit completed<br>";
	}else{
		echo "<br><br><b>$edit_mod_confirmed Edit performed with following notes:</b><br>";
		echo "$mod_status<br>";
	}
	?>
		<form action="<?php echo $PHP_SELF; ?>" method="POST">
			<input type="hidden" name="cancel" value="none">
			<input type="submit" value="Return to Status">
		</form>
<?php
}

//---------------------------------------------------------------------------
// INSTALL MOD (Confirmation Request)
if($install_mod != ""){
	$first_menu=FALSE;
?>
		<br>
Request to install TNG mod <?php echo $install_mod;?>.<br>
Confirm request or cancel<br><br>
		<table><tr>
			<td>
				<form action="<?php echo $PHP_SELF; ?>" method="POST">
					<input type="hidden" name="install_mod_confirmed" value="<?php echo $install_mod; ?>">
					<input type="submit" value="Confirm Install">
				</form>
			</td>
			<td>
				<form action="<?php echo $PHP_SELF; ?>" method="POST">
					<input type="hidden" name="cancel" value="none">
					<input type="submit" value="Cancel">
				</form>
			</td>
		</tr></table>
<?php
}

//----------------------------------------------------------------------------
// INSTALL MOD (Confirmed)
if($install_mod_confirmed != ""){
	$first_menu=FALSE;
	echo "<br>Confirmed request to install TNG mod $install_mod_confirmed.<br>";
	$mod_status = mod_install($rootpath,$path,$install_mod_confirmed);
	if($mod_status == "installed"){
		echo "<br><br>$install_mod_confirmed Installed<br>";
	}else{
		echo "<br><br><b>$install_mod_confirmed Not Installed due to the following errors:</b><br>";
		echo "$mod_status<br>";
	}
?>
		<form action="<?php echo $PHP_SELF; ?>" method="POST">
			<input type="hidden" name="cancel" value="none">
			<input type="submit" value="Return to Status">
		</form>
<?php
}

//---------------------------------------------------------------------------
// DELETE MOD Config File (Confirmation Request)
if($delete_cfg != ""){
	$first_menu=FALSE;
?>
		<br>
Request to delete MOD configuration file <?php echo $delete_cfg;?>.<br>
<font color="red">You can not undo this operation.  You will need to re-download this mod if you wish to install or remove it later.</font><br>
Confirm request or cancel<br><br>
		<table><tr>
			<td>
				<form action="<?php echo $PHP_SELF; ?>" method="POST">
					<input type="hidden" name="delete_cfg_confirmed" value="<?php echo $delete_cfg; ?>">
					<input type="submit" value="Confirm Deletion">
				</form>
			</td>
			<td>
				<form action="<?php echo $PHP_SELF; ?>" method="POST">
					<input type="hidden" name="cancel" value="none">
					<input type="submit" value="Cancel">
				</form>
			</td>
		</tr></table>
<?php
}

//----------------------------------------------------------------------------
// DELETE MOD Config File (Confirmed)
if($delete_cfg_confirmed != ""){
	$first_menu=FALSE;
	echo "<br>Confirmed request to delete the TNG mod config file $delete_cfg_confirmed.<br>";
	if (unlink($path . $delete_cfg_confirmed)){
		echo "<br><br>$delete_cfg_confirmed Deleted<br>";
	}else{
		echo "<br><br><b>Unable to delete $delete_cfg_confirmed. Please remove this file manually.<br>";
	}
?>
		<form action="<?php echo $PHP_SELF; ?>" method="POST">
			<input type="hidden" name="cancel" value="none">
			<input type="submit" value="Return to Status">
		</form>
<?php
}


//----------------------------------------------------------------------------------
//	This is the Main Status Display Page
//	This will be executed if none of the other sub-pages were called as listed above
//
if($first_menu){
	showtime("0");
	$starttime = $prevtime;
	$num_mods = 0;
	$files = scan4dir($path);
	foreach( $files as $file){	
		if(substr($file,-3) == $extension){
			$num_mods += 1;
  		$mod_files[$num_mods]=$file;
			if($num_mods == 1){
				?>
				<table cellpadding="3" cellspacing="1" border="0">
					<tr>
						<td class="fieldnameback fieldname">&nbsp;<b><?php echo $admtext['name']; ?></b>&nbsp;</td>
						<td class="fieldnameback fieldname">&nbsp;<b><?php echo $admtext['description']; ?></b>&nbsp;</td>
						<td class="fieldnameback fieldname">&nbsp;<b>Config File Name</b>&nbsp;</td>
						<td class="fieldnameback fieldname">&nbsp;<b>Version</b>&nbsp;</td>
						<td class="fieldnameback fieldname">&nbsp;<b>Status</b>&nbsp;</td>
					</tr>
				<?php
  		}
  		$mod_config_file = fix_file(file_get_contents("$path$file"));
  		$config_section = split("%target:",$mod_config_file);
  		$mod_name = ereg_replace(".*%name:([^%]*).*","\\1",$config_section[0]);
  		$mod_version = ereg_replace(".*%version:([^%]*).*","\\1",$config_section[0]);
  		$mod_desc = ereg_replace(".*%description:([^%]*).*","\\1",$config_section[0]);

  		$mod_command = "";
  		$mod_edit = "";
  	
  		echo "<tr>";
  		$mod_status = status_check($rootpath,$path,$mod_config_file);
  		showtime("DSP:1");
  		if($mod_status == "ok" || $mod_status == "pok"){
  			$mod_status = "ok";
  			$mod_statclass = "avail";
  			$mod_command = "<br>
  			<form action=\"$PHP_SELF\" method=\"POST\">
					<input type=\"hidden\" name=\"install_mod\" value=\"$file\">
					<input type=\"submit\" value=\"Install\">
				</form>";
  		}elseif ($mod_status == "installed" || $mod_status == "pinstalled"){
  			$mod_statclass = "inst";
  			$mod_command = "<br>
  			<form action=\"$PHP_SELF\" method=\"POST\">
					<input type=\"hidden\" name=\"remove_mod\" value=\"$file\">
					<input type=\"submit\" value=\"Remove\">
				</form>";
				if ($mod_status == "pinstalled") {
					$mod_edit = "
  				<form action=\"$PHP_SELF\" method=\"POST\">
						<input type=\"hidden\" name=\"edit_mod\" value=\"$file\">
						<input type=\"submit\" value=\"Edit\">
					</form>";
				}
  			$mod_status = "installed";
  		}else{
  			$mod_statclass = "failed";
  			$mod_command = "<br>
  			<form action=\"$PHP_SELF\" method=\"POST\">
					<input type=\"hidden\" name=\"clean_mod\" value=\"$file\">
					<input type=\"submit\" value=\"Cleanup\">
				</form>";
  		}
  		$mod_mgmt = "<br>
  			<form action=\"$PHP_SELF\" method=\"POST\">
					<input type=\"hidden\" name=\"delete_cfg\" value=\"$file\">
					<input type=\"submit\" value=\"Delete\">
				</form>";
   		
  		echo "<td class=\"lightback\"><span class=\"normal\"><b>$mod_name</b></span></td>
  				<td class=\"lightback\" width=400px><span class=\"normal\">$mod_desc</span></td>
  				<td class=\"lightback\"><center><span class=\"normal\">$file</span>$mod_mgmt</center></td>
  				<td class=\"lightback\"><span class=\"normal\">$mod_version</span></td>
  				<td class=$mod_statclass><span class=\"normal\">$mod_status</span>$mod_command$mod_edit</td>";
  		echo "</tr>\n";
  	}
	}
	if($num_mods == 0){
 		echo "<br>No Mod definition files ($extension) found in the mod folder [$path].<br>";
	} else {
		echo $mod_table_end;
	}
	$prevtime = $starttime;
	showtime("End");
}
?>
</table>
</div>
</td>
</tr>
</table>
</body>
</html>
<?php
exit;

//-------------------------------------------------------------------------------------
// FUNCTION scan4dir
//	This routine will return a sorted directory list in an array.
//	PHP 5 has a function (scandir) that does this, so this is just for backward compatibility
//
function scan4dir($dir){
	$listDir = array();
	if($handler = opendir($dir) or die("Unable to open $path")){
		while (FALSE !== ($sub = readdir($handler))){
			if(is_file($dir."/".$sub)){
				$listDir[] = $sub;
			}
		}
	}
	sort($listDir);
	return $listDir;
}

	
//-------------------------------------------------------------------------------------
// FUNCTION mod_install
//
function mod_install($rootpath,$path,$config_name){
//
// This function must open the config file
//		locate all target files
//		locate all target code locations
//		modify the target files by inserting or replacing all code pieces, and creating all files
//		
	$stat_str = "installed";
	$total_locations = 0;
	$good_locations = 0;
	$installed_locations = 0;
	$total_files = 0;
	$total_files_created = 0;
	$num_errors = 0;
	$errors = "";

	showtime("Ins0");
	$config = fix_file(file_get_contents("$path$config_name"));
	showtime("Ins1");
	if(strpos($config,"%target:") === FALSE){
		return("Pkg Error:no target files");			
	}
	$sections = split("%target:",$config);
	for($i=1;isset($sections[$i]);$i++){
		$target_file = trim(ereg_replace("([^%]*)%.*","\\1",$sections[$i]));
		showtime("Ins2");
		logit("<br><b>Section $i:</b> $target_file<br>");
		if(!file_exists("$rootpath$target_file")){
			if(strpos($sections[$i],"%fileoptional:%") !== FALSE) continue;
			return("Missing file: $target_file");
		}
		$target_contents = fix_file(file_get_contents("$rootpath$target_file"));
		if($target_contents ==""){
			return("Empty file: $target_file<br>");
		}else{
			$locations = split("%location:%",$sections[$i]);
			for($j=1;isset($locations[$j]);$j++){
				$total_locations++;
				$target_code = split("%end:%",$locations[$j]);
				$target_code_trimmed = trim($target_code[0]);
				logit("<br><b>Location $j:</b> target code is:<br>[[" . htmlspecialchars($target_code_trimmed) . "]]<br>");
				if($target_code_trimmed == ""){
					$num_errors++;
					$errors .= "f:$target_file:Location $j:missing %end:%<br>";
				}else{
					if(($first1 = strpos($target_contents,$target_code_trimmed)) === FALSE){
						$num_errors++;
						$errors .= "$target_file:Location $j:bad target<br>";
						logit("Could not find target.<br>");
					} else {
						showtime("Location found at $first1");
						$good_locations++;
						if(strpos($locations[$j],"%insert:before%") !== FALSE){
							$mod_insertbefore = ereg_replace(".*%insert:before%[\r\n][\r\n](.*)%end:%.*","\\1",$locations[$j]);
							logit("Mod code inserted.<br>");
							$target_contents = str_replace($target_code_trimmed,$mod_insertbefore . $target_code_trimmed,$target_contents);
						}
						if(strpos($locations[$j],"%triminsert:before%") !== FALSE){
							$mod_insertbefore = trim(ereg_replace(".*%triminsert:before%(.*)%end:%.*","\\1",$locations[$j]));
							logit("Mod code trimmed and inserted.<br>");
							$target_contents = str_replace($target_code_trimmed,$mod_insertbefore . $target_code_trimmed,$target_contents);
						}
						if(strpos($locations[$j],"%insert:after%") !== FALSE){
							$mod_insertafter = ereg_replace(".*%insert:after%(.*)[\r\n][\r\n]%end:%.*","\\1",$locations[$j]);
							logit("Mod code inserted.<br>");
							$target_contents = str_replace($target_code_trimmed,$target_code_trimmed . $mod_insertafter,$target_contents);
						}
						if(strpos($locations[$j],"%triminsert:after%") !== FALSE){
							$mod_insertafter = trim(ereg_replace(".*%triminsert:after%(.*)%end:%.*","\\1",$locations[$j]));
							logit("Mod code trimmed and inserted.<br>");
							$target_contents = str_replace($target_code_trimmed,$target_code_trimmed . $mod_insertafter,$target_contents);
						}
						if(strpos($locations[$j],"%replace:%") !== FALSE){
							$mod_replace = ereg_replace(".*%replace:%(.*)%end:%.*","\\1",$locations[$j]);
							logit("Mod code replaced.<br>");
							$target_contents = str_replace($target_code_trimmed,$mod_replace,$target_contents);
						}
						if(strpos($locations[$j],"%trimreplace:%") !== FALSE){
							$mod_replace = trim(ereg_replace(".*%trimreplace:%(.*)%end:%.*","\\1",$locations[$j]));
							logit("Mod code replaced.<br>");
							$target_contents = str_replace($target_code_trimmed,$mod_replace,$target_contents);
						}
						//------------------
						$new_files = split("%newfile:",$locations[$j]);
						for($k=1;isset($new_files[$k]);$k++){
							$mod_filename = trim(ereg_replace("([^%]*)%.*","\\1",$new_files[$k]));
							if(strlen($mod_filename) < 3 || strlen($mod_filename) > 70){
								$num_errors++;
								$errors .= "$mod_filename:Newfile name missing<br>";
							}else{
								$total_files++;
								logit("Have to create file $mod_filename<br>");
								$new_filecode = trim(ereg_replace(".*%fileversion:[^%]*%(.*)%fileend:%.*","\\1",$new_files[$k]));
								if( $mod_handle = fopen("$rootpath$mod_filename", 'wb') ){
									fwrite($mod_handle, $new_filecode);
									$total_files_created++;
								} else {
									$perms = fileperms("$rootpath$mod_filename");
									logit("<br>Unable to write to $mod_filename, [error $mod_handle]<br>Check permissions, currently [" . sprintf("%o",$perms&0777) . "].<br>");
									$num_errors++;
									$errors .= "$mod_filename:is not writable, check permissions<br>";
								}
								fclose($mod_handle);
							}
						}
						//------------------
						$copy_files = split("%copyfile:",$locations[$j]);
						for($k=1;isset($copy_files[$k]);$k++){
							$copy_filename = trim(ereg_replace("([^%]*)%.*","\\1",$copy_files[$k]));
							if(strlen($copy_filename) < 3 || strlen($copy_filename) > 70){
								$num_errors++;
								$errors .= "$copy_filename:Copyfile name missing<br>";
							}else{
								$total_copy_files++;
								logit("Have to copy file $path$copy_filename to $rootpath$copy_filename<br>");
								if(copy($path . $copy_filename,$rootpath . $copy_filename) === FALSE){
									logit("<br>Unable to copy to $rootpath$copy_filename, [error $mod_handle]<br>Check permissions, must be writeable.<br>");
									$num_errors++;
									$errors .= "$copy_filename:is not writable, check permissions<br>";
								}else{
									logit("File $path$copy_filename copied to $rootpath$copy_filename<br><br>");
								}
							}
						}
						//------------------
						$copy_files = split("%copyfile2:",$locations[$j]);
						for($k=1;isset($copy_files[$k]);$k++){
							logit("Copy File 2 <br>");
							$copy_from = trim(ereg_replace("([^:]*):.*","\\1",$copy_files[$k]));
							$copy_to = trim(ereg_replace("[^:]*:([^%]*)%.*","\\1",$copy_files[$k]));
							if(strlen($copy_from) < 3 || strlen($copy_from) > 70){
								$num_errors++;
								$errors .= "$copy_from:Copyfrom file name missing<br>";
							}elseif(strlen($copy_to) < 3 || strlen($copy_to) > 70){
								$num_errors++;
								$errors .= "$copy_to:Copyto file name missing<br>";
							}else{
								$total_copy_files++;
								logit("Have to copy file $path$copy_from to $rootpath$copy_to<br>");
								if(copy($path . $copy_from,$rootpath . $copy_to) === FALSE){
									logit("<br>Unable to copy to $rootpath$copy_to, [error $mod_handle]<br>Check permissions, must be writeable.<br>");
									$num_errors++;
									$errors .= "$copy_to:can not write file, check permissions<br>";
								}else{
									logit("File $path$copy_from copied to $rootpath$copy_to<br>");
								}
							}
						}
						//------------------
					}
				}
			}
			$filename = "$rootpath$target_file";
			logit("Rewrite target file $filename<br>");
			if (is_writable($filename)) {
				if (!$handle = fopen($filename, 'wb')) {
					logit("Cannot open file ($filename) for writing.<br>");
					$num_errors++;	
					$errors .= "$target_file:is not writable, check permissions<br>";
    		}else{
					if (fwrite($handle, $target_contents) === FALSE) {
						logit("Cannot write to file ($filename)");
						$num_errors++;
						$errors .= "$target_file:is not writable, check permissions<br>";
					}else{
						logit("File $filename written.<br>");
					}
				}
				fclose($handle);
			}else{
				logit("The file $filename is not writable<br>");
				$num_errors++;	
				$errors .= "$target_file:is not writable, check permissions<br>";
			}
		}
	}
	logit("<br><b>Total Errors:</b> $num_errors<br>");
	logit("Total new files: $total_files, Created:$total_files_created<br>");
		
	if($num_errors != 0){
		$stat_str = $errors;
	}else{
		if(($total_files == $total_files_created)){
			$stat_str = "installed";
		}else{
			$num_errors++;
			$errors .= "Not all sections installed<br>";
			$stat_str = $errors;
		}
	}
return($stat_str);
}
//-------------------------------------------------------------------------------------
// FUNCTION mod_remove
//
function mod_remove($path,$config_name){
//
// This function must open the config file
//		locate all target files
//		locate all target code locations
//		modify the target files by removing all inserts, replacing all replaces, deleting all files
//		
	$stat_str = "removed";
	$total_locations = 0;
	$good_locations = 0;
	$installed_locations = 0;
	$total_files = 0;
	$total_files_deleted = 0;
	$num_errors = 0;
	$errors = "";

	$config = fix_file(file_get_contents("$config_name"));
	
	if(strpos($config,"%target:") === FALSE){
		return("Pkg Error:no target files");			
	}
	$sections = split("%target:",$config);
	for($i=1;isset($sections[$i]);$i++){
		$target_file = trim(ereg_replace("([^%]*)%.*","\\1",$sections[$i]));
		logit("<br><b>Section $i:</b> $path$target_file<br>");
		if(!file_exists("$path$target_file")){
			$num_errors++;
			$errors .= "Missing file: [$path$target_file]<br>";
			logit("Missing file: [$path$target_file]");
			continue;
		}
		$target_contents = fix_file(file_get_contents("$path$target_file"));
		if($target_contents ==""){
			$num_errors++;
			$errors .= "Empty file: [$path$target_file]<br>";
			logit("Empty file: [$path$target_file]");
			continue;
		}else{
			$locations = split("%location:%",$sections[$i]);
			for($j=1;isset($locations[$j]);$j++){
				logit("<br><b>Location $j:</b><br>");
				$total_locations++;
				$target_code = split("%end:%",$locations[$j]);
				if($target_code[0] == ""){
					$num_errors++;
					$errors .= "f:$target_file:Location $j:missing %end:%<br>";
				}else{
					if( (($first1 = strpos($target_contents,trim($target_code[0]))) === FALSE) && (strpos( $target_code[1] ,"%replace:" ) === FALSE) && (strpos( $target_code[1] ,"%trimreplace:" ) === FALSE)){
						$num_errors++;
						logit("Target search was [" . trim(htmlspecialchars($target_code[0])) . "]<br>");
						$errors .= "$target_file:Location $j:bad target<br>";
					} else {
						$good_locations++;
						if(strpos($locations[$j],"%insert:before") !== FALSE){
							$mod_removeinsert = ereg_replace(".*%insert:before%[\r\n][\r\n](.*)%end:%.*","\\1",$locations[$j]);
							$target_contents = str_replace($mod_removeinsert,"",$target_contents);
							logit("Mod inserted code removed.<br>");
						}
						if(strpos($locations[$j],"%insert:after") !== FALSE){
							$mod_removeinsert = ereg_replace(".*%insert:after%(.*)[\r\n][\n\n]%end:%.*","\\1",$locations[$j]);
							$target_contents = str_replace($mod_removeinsert,"",$target_contents);
							logit("Mod removed code removed.<br>");
						}
						if(strpos($locations[$j],"%triminsert:") !== FALSE){
							$mod_removeinsert = trim(ereg_replace(".*%triminsert:[^%]*%(.*)%end:%.*","\\1",$locations[$j]));
							$target_contents = str_replace($mod_removeinsert,"",$target_contents);
							logit("Mod code trimmed and removed.<br>");
						}
						if(strpos($locations[$j],"%replace:") !== FALSE){
							$mod_removereplace = ereg_replace(".*%replace:%(.*)%end:%.*","\\1",$locations[$j]);
							if(FALSE !== ($target_contents = str_replace($mod_removereplace,trim($target_code[0]),$target_contents))){
								logit("Original code replaced.<br>");
							}else{
								logit("Unable to replace original code, not found.");
							}
						}
						if(strpos($locations[$j],"%trimreplace:") !== FALSE){
							$mod_removereplace = trim(ereg_replace(".*%trimreplace:%(.*)%end:%.*","\\1",$locations[$j]));
							$target_contents = str_replace($mod_removereplace,trim($target_code[0]),$target_contents);
							logit("Original code trimmed and replaced.<br>");
						}
						$new_files = split("%newfile:",$locations[$j]);
						for($k=1;isset($new_files[$k]);$k++){
							$mod_filename = trim(ereg_replace("([^%]*)%.*","\\1",$new_files[$k]));
							if(strlen($mod_filename) < 3 || strlen($mod_filename) > 70){
								$num_errors++;
								$errors .= "$mod_filename:Newfile name missing<br>";
							}else{
								$total_files++;
								if(file_exists("$path$mod_filename")){
									$total_files_deleted++;
									if(!unlink("$path$mod_filename")){
										$perms = fileperms("$path$mod_filename");
										$num_errors++;
										$errors .= "$mod_filename:Can not delete, permissions are [" . sprintf("%o",$perms&0777) . "].<br>";
									}
								}
							}
						}
					}
				}
			}
			if( $mod_handle = fopen("$path$target_file", 'wb') ){
				fwrite($mod_handle, $target_contents);
				fclose($mod_handle);
			} else {
				$perms = fileperms("$path$target_file");
				logit("<br>Unable to write to $target_file, [error $mod_handle]<br>Check permissions, currently [" . sprintf("%o",$perms&0777) . "].<br>");
			}
		}
	}
	logit("Errors: $num_errors<br>");
	logit("Total new files: $total_files, Deleted:$total_files_deleted<br>");
		
	if($num_errors != 0){
		$stat_str = $errors;
	}else{
		if(($total_files == $total_files_deleted)){
			$stat_str = "removed";
		}else{
			$num_errors++;
			$errors .= "Not all sections removed<br>";
			$stat_str = $errors;
		}
	}
return($stat_str);
}

//--------------------------------------------------------------------------------------

function status_check($rootpath,$path,$config){
//
// This function must examine the mod config file and
//		verify all target files exist
//		identify whether the mod is already installed
//		verify all target code locations can be found
//		verify all target code locations are unique
//		identify all new files
//		identify if new files already exist and determine their version number
//		if their version number is the same, then register as installed, else request user delete the file
//
	$stat_str = "ok";
	$stat_parm = "";
	$total_locations = 0;
	$good_locations = 0;
	$installed_locations = 0;
	$total_files = 0;
	$total_files_exist = 0;
	$total_files_installed = 0;
	$num_errors = 0;
	$not_unique = 0;
	$errors = "";

	showtime("Stat0");

	if(strpos($config,"%target:") === FALSE){
		return("Pkg Error:no target files");			
	}
	$sections = split("%target:",$config);

	for($i=1;isset($sections[$i]);$i++){
		$target_file = trim(ereg_replace("([^%]*)%.*","\\1",$sections[$i]));
		showtime("<b>Section $i:</b> $target_file");
		if(!file_exists("$rootpath$target_file")){
			if(strpos($sections[$i],"%fileoptional:%") !== FALSE) continue;
			return("Missing file: $rootpath$target_file");
		}
		$target_contents = fix_file(file_get_contents("$rootpath$target_file"));
		if($target_contents == ""){
			return("Empty file: $target_file<br>");
		}else{
			if(strpos($sections[$i],"%parameter:") !== FALSE){
				$parameters = split("%parameter:",$sections[$i]);
				for($k=1;isset($parameters[$k]);$k++){
					$param_name = trim(ereg_replace("([^:]*):.*","\\1",$parameters[$k]));
					$param_value = trim(ereg_replace("[^:]*[:\" ]*([^:\"%]*).*","\\1",$parameters[$k]));
					$stat_parm = "p";
				}
			}
			if(strpos($sections[$i],"%location:%") === FALSE){
				$num_errors++;
				$errors .= "Section $i:missing %location:% keyword<br>";
				logit("Section $i, [" . htmlspecialchars($sections[$i]) . "] Missing %location:%<br>");
			}else{
				$locations = split("%location:%",$sections[$i]);
				for($j=1;isset($locations[$j]);$j++){
					showtime("Loc $j");
					$total_locations++;
					if(strpos($locations[$j],"%end:%") === FALSE){
						$num_errors++;
						$errors .= "$target_file:Location $j:missing %end:%<br>";
						showtime("Error: Missing end");
					}else{
						$target_code = split("%end:%",$locations[$j]);
						if( (($first1 = strpos($target_contents,trim($target_code[0]))) === FALSE) && (strpos( $target_code[1] ,"%replace:" ) === FALSE) && (strpos( $target_code[1] ,"%trimreplace:" ) === FALSE)){
							$num_errors++;
							$errors .= "$target_file:Location $j:bad target<br>";
							showtime("Error: no target match of [" . trim($target_code[0]) . "] in [" . $target_contents . "] ");
						} else {
							showtime("located targetcode:");
							$good_locations++;
							showtime("Found at: $first1");
							if(	(($last1 = strpos($target_contents,trim($target_code[0]),$first1+1)) !== FALSE)){
								$num_errors++;
								$not_unique++;
								$errors .= "$target_file:Location $j:not unique<br>";
								showtime("Error: Found a second target");
							}else{
								showtime("Found only one");
								// location is good, check to see if it is already installed
								if((strpos($target_code[1],"%insert:") === FALSE) && (strpos($target_code[1],"%replace:") === FALSE) && (strpos($target_code[1],"%triminsert:") === FALSE) && (strpos($target_code[1],"%trimreplace:") === FALSE)){
									$num_errors++;
									$errors .= "$target_file:Location $j:no action<br>";
								}else{
									showtime("located directive:");
									if(strpos($target_code[1],"%insert:before") !== FALSE){
										$mod_newcode = ereg_replace(".*%insert:before%(.*)","\\1",$target_code[1]);
									}elseif(strpos($target_code[1],"%insert:after") !== FALSE){
										$mod_newcode = ereg_replace(".*%insert:after%(.*)","\\1",$target_code[1]);
									}elseif(strpos($target_code[1],"%triminsert:") !== FALSE){
										$mod_newcode = trim(ereg_replace(".*%triminsert:[^%]*%(.*)","\\1",$target_code[1]));
									}elseif(strpos($target_code[1],"%replace:") !== FALSE){
										$mod_newcode = ereg_replace(".*%replace:%(.*)","\\1",$target_code[1]);
									}else{
										$mod_newcode = trim(ereg_replace(".*%trimreplace:%(.*)","\\1",$target_code[1]));
									}					
									showtime("Extracted new code:");
									if(($first1 = strpos($target_contents,trim($mod_newcode))) !== FALSE){
										$installed_locations++;
										$errors .= "$target_file:Location $j:installed<br>";
										showtime("Extracted new code from $target_file: Location: $j: [" . htmlspecialchars($mod_newcode) . "]installed<br>");
									}else{
										$errors .= "$target_file:Location $j:not installed<br>";
									}
								}
							}
						}
					}
	
					//=============
					// Check embedded files and the versions
					$new_files = split("%newfile:",$locations[$j]);
					for($k=1;isset($new_files[$k]);$k++){
						$fileinfo = substr($new_files[$k],0,70);
						showtime("X1");
						$mod_filename = trim(ereg_replace("([^%]*)%.*","\\1",$fileinfo));
						showtime("X2");
						$mod_filever =  trim(ereg_replace(".*%fileversion:([^%]*)%.*","\\1",$fileinfo));
						showtime("X3");
						if(strlen($mod_filename) < 3 || strlen($mod_filename) > 70){
							$num_errors++;
							$errors .= "$mod_filename:Newfile name missing<br>";
						}else{
							$total_files++;
							if(file_exists("$rootpath$mod_filename")){
								$total_files_exist++;
								showtime("NF");
								$target_newfile = fix_file(file_get_contents("$rootpath$mod_filename"));
								if(strpos($target_newfile,"%version:") !== FALSE){
									showtime("NFver");
									$newfile_ver_string = split("%version:",$target_newfile);
									$newfile_ver_str = substr($newfile_ver_string[1],0,30);
									$newfile_ver =  trim(ereg_replace("([^%]*)%.*","\\1",$newfile_ver_str));
									if($mod_filever == $newfile_ver){
										$total_files_installed++;
										$errors .= "$mod_filename installed<br>";
									}else{
										$errors .= "$mod_filename V$mod_filever not installed, version $newfile_ver is<br>";
									}
								}else{
									$errors .= "Existing $mod_filename does not have a version number<br>";
								}
							}else{
								$errors .= "$mod_filename V$mod_filever not installed<br>";
							}
						}
					}
					//=============
					$copy_files = split("%copyfile:",$locations[$j]);
					for($k=1;isset($copy_files[$k]);$k++){
						$fileinfo = substr($copy_files[$k],0,70);
						showtime("C1");
						$copy_filename = trim(ereg_replace("([^%]*)%.*","\\1",$fileinfo));
						showtime("C2");
						if(strlen($copy_filename) < 3 || strlen($copy_filename) > 70){
							$num_errors++;
							$errors .= "$copy_filename:Copy file name is missing<br>";
						}else{
							$total_copies++;
							if(file_exists("$rootpath$copy_filename")){
								$total_copies_exist++;
								showtime("CF");
							}else{
								if(!file_exists("$path$copy_filename")){
									$num_errors++;
									$errors .= "$rootpath$copy_filename not installed<br>";
									$errors .= "Local copy of $path$copy_filename for installation is missing<br>";
								}
								$errors .= "$copy_filename not installed<br>";
							}
						}
					}
					//=============
					$copy_files = split("%copyfile2:",$locations[$j]);
					for($k=1;isset($copy_files[$k]);$k++){
						$fileinfo = substr($copy_files[$k],0,140);
						$copy_from = trim(ereg_replace("([^:]*):.*","\\1",$fileinfo));
						$copy_to = trim(ereg_replace("[^:]*:([^%]*)%.*","\\1",$fileinfo));
						if(strlen($copy_from) < 3 || strlen($copy_from) > 70){
							$num_errors++;
							$errors .= "$copy_from:Copy from file name is missing<br>";
						}elseif(strlen($copy_to) < 3 || strlen($copy_to) > 70){
							$num_errors++;
							$errors .= "$copy_to:Copy to file name is missing<br>";
							$total_copies++;
						}else{
							if(file_exists("$rootpath$copy_to")){
								$total_copies_exist++;
							}else{
								if(!file_exists("$path$copy_from")){
									$num_errors++;
									$errors .= "Local copy of $path$copy_from for installation is missing<br>";
								}else{
									$errors .= "$rootpath$copy_to not installed<br>";
								}
							}
						}
					}
				}
			}
		}
	}
	if($num_errors != 0){
		$stat_str = $errors;
	}else{
		if(($total_locations == $installed_locations) && ($total_files == $total_files_installed)){
			$stat_str = "installed";
		}else{
			if(!(($total_locations == $good_locations) && ($total_files_installed == 0) && ($installed_locations == 0))){
				$num_errors++;
				$errors .= "Not all segments installed<br>";
				$stat_str = $errors;
			}
		}
	}
	showtime("Statend:$target_file");
	return($stat_parm . $stat_str);
}


//--------------------------------------------------------------------------------------

function mod_edit($rootpath,$path,$config_name){
//
//
	$result_str = "<b>Parameters</b><br>";
	$config = fix_file(file_get_contents("$path$config_name"));

	if(strpos($config,"%target:") === FALSE){
		return("Parameter Edit Error: no target file located<br>");			
	}
	$sections = split("%target:",$config);
	for($i=1;isset($sections[$i]);$i++){
		$target_file = trim(ereg_replace("([^%]*)%.*","\\1",$sections[$i]));
		showtime("Section $i: $target_file");
		$target_full_filename = "$rootpath$target_file";
		if(!file_exists($target_full_filename)){
			return("Missing file: $target_full_filename");
		}
		$target_contents = fix_file(file_get_contents($target_full_filename));
		if($target_contents ==""){
			return("Empty file: $target_file<br>");
		}else{
			if(strpos($sections[$i],"%parameter:") !== FALSE){
				$parameters = split("%parameter:",$sections[$i]);
				$param_name = "";
				$param_value = "";
				for($k=1;isset($parameters[$k]);$k++){
					$param_name = ereg_replace("([^:]*):.*","\\1",$parameters[$k]);
					$param_value = ereg_replace("[^:]*[:\" ]*([^:\"%]*).*","\\1",$parameters[$k]);
					if(strpos($parameters[$k],"%desc:") === FALSE){
						$num_errors++;
						$errors .= "Parameter definition error, missing description %desc:%<br>";
					}else{
						$param_desc = ereg_replace(".*%desc:([^%]*)%.*","\\1",$parameters[$k]);
					}
					$result_str .= "$param_desc&nbsp;
					<input type=\"hidden\" name=\"name$k\" value=\"$param_name\">
					<input type=\"hidden\" name=\"file$k\" value=\"$target_full_filename\">
					<input type=\"text\" name=\"value$k\" value=\"$param_value\">";
					if($param_default !=  ""){
						$result_str .= "&nbsp;&nbsp;Default Value: [ $param_default ]";
					}
					$result_str .= "<br>";
				}
				$num_param = $k - 1;
				$result_str .= "
				<input type=\"hidden\" name=\"num_param\" value=\"$num_param\">
				<br>";
			}
		}
	}
	return($result_str);
}

//--------------------------------------------------------------------------------------

function mod_read_edit($rootpath,$path,$config_name){
//
//
	$result_str = "<b>Parameters read from Files</b><br>";
	$config_file = "$path$config_name";
	$config = fix_file(file_get_contents("$config_file"));
	$save_flag = FALSE;

	if(strpos($config,"%target:") === FALSE){
		return("Parameter Read Error: no target file located<br>");			
	}
	$sections = split("%target:",$config);
	for($i=1;isset($sections[$i]);$i++){
		$target_file = trim(ereg_replace("([^%]*)%.*","\\1",$sections[$i]));
		showtime("Read Value Section $i: $target_file");
		$target_full_filename = "$rootpath$target_file";
		if(!file_exists($target_full_filename)){
			return("Missing file: $target_full_filename");
		}
		$target_contents = fix_file(file_get_contents($target_full_filename));
		if($target_contents ==""){
			return("Empty file: $target_file<br>");
		}else{
			if(strpos($sections[$i],"%parameter:") !== FALSE){
				$parameters = split("%parameter:",$sections[$i]);
				$param_name = "";
				$param_value = "";
				$param_config_value = "";
				// For each parameter, read the target file value, then store it back to the configuration file
				for($k=1;isset($parameters[$k]);$k++){
					$param_name = ereg_replace("([^:]*):.*","\\1",$parameters[$k]);
					$param_config_value = ereg_replace("[^:]*[:\"]*([^%\"]*).*","\\1",$parameters[$k]);
					$quote_it = "";
					if("$" == substr($param_name,0,1)) $quote_it = "\\";
					$param_file_value = ereg_replace(".*$quote_it" . $param_name . " =[ \"]*([^;\"]*).*","\\1",$target_contents);
					if($param_config_value != $param_file_value){
						logit("Updating $param_name value of [" . htmlspecialchars($param_file_value) . "] to the mod config file. </br>");		
						$config = ereg_replace("(.*parameter:" . $quote_it . $param_name . ":)[^%]*(%.*)","\\1" . $param_file_value . "\\2",$config);
						$save_flag = TRUE;
					}
				}
			}
		}
	}
	if($save_flag){
		if( $mod_handle = fopen($config_file, 'wb') ){
			fwrite($mod_handle, $config);
			fclose($mod_handle);
			$result_str .= "File: " . $config_file . " rewritten.<br>";
		} else {
			$perms = fileperms($config_file);
			logit("<br>Unable to write to " . $config_file . ", [error $mod_handle]<br>Check permissions, currently [" . sprintf("%o",$perms&0777) . "].<br>");
		}
	}
	return($result_str);
}

//--------------------------------------------------------------------------------------

function mod_edit_action($rootpath,$config_file,$_POST){
//
//
	$result_str = "Parameter Editor<br><br>";
	$num_param=0;
	if(isset($_POST[num_param])) $num_param = $_POST[num_param];
	if($num_param==0) return($result_str . "No parameter definitions");
	
	
	for($j=1;$j<=$num_param;$j++){
		$result_str .= "Parameter $j<br>";
		$config = fix_file(file_get_contents($_POST["file$j"]));
		$result_str .= "File: " . $_POST["file$j"] . " Parameter: " . $_POST["name$j"] . " Value: " . $_POST["value$j"] . "<br>";
		$new_config = ereg_replace("(.*\\" . $_POST["name$j"] . ")[0-9\. =]*(;.*)","\\1 = " . $_POST["value$j"] . "\\2",$config);		
		if( $mod_handle = fopen($_POST["file$j"], 'wb') ){
			fwrite($mod_handle, $new_config);
			fclose($mod_handle);
			$result_str .= "File: " . $_POST["file$j"] . " rewritten.<br>";
		} else {
			$perms = fileperms($_POST["file$j"]);
			logit("<br>Unable to write to " . $_POST["file$j"] . ", [error $mod_handle]<br>Check permissions, currently [" . sprintf("%o",$perms&0777) . "].<br>");
		}
//--------
		$config = fix_file(file_get_contents($config_file));
		$new_config = ereg_replace("(.*parameter:\\" . $_POST["name$j"] . ":)[0-9\.]*(%.*)","\\1" . $_POST["value$j"] . "\\2",$config);
		if( $mod_handle = fopen($config_file, 'wb') ){
			fwrite($mod_handle, $new_config);
			fclose($mod_handle);
			$result_str .= "File: " . $config_file . " rewritten.<br>";
		} else {
			$perms = fileperms($config_file);
			logit("<br>Unable to write to " . $config_file . ", [error $mod_handle]<br>Check permissions, currently [" . sprintf("%o",$perms&0777) . "].<br>");
		}
	}
	return($result_str);
}

//---------------------------------------------------------------------------------
// A debug function to allow tracking of where the most time is spent in the code
// This can be remove in the production version along with all of the calls placed
// throughout the code
//
function showtime($location){
		global $prevtime;
    list($pusec, $psec) = explode(" ", $prevtime);
    $ptim = $psec+$pusec;
    $prevtime=microtime();
    list($usec, $sec) = explode(" ", $prevtime);
		$tim = $sec + $usec;
		$diff = $tim-$ptim;
//		if($diff > 0.01) echo "[$location>> $diff]<br>";
//    echo "[" . htmlspecialchars($location) . "]<br>";
    return;
}

//----------------------------------------------------------------------------
//
// This function is used to patch up the differences between DOS and Unix formatted files
// Although most of the files start out the same, ftp transfers and copying of files can unknowingly
// change the format when moving the files around.  The end of line characters get changed and then
// the search and replace functions begin to fail when it involves multiple lines.
// This slows down the conversion process but seems to allow for the differences given that different
// versions of php provide different levels of support for TEXT_FILE reads
//
function fix_file($instr) {
		$ret_str = ereg_replace("([^\r])\n","\\1\r\n",$instr);  // replace all standalone LFs with CRLF
		$instr = ereg_replace("\r([^\n])","\r\n\\1",$ret_str);  // replace all standalone CRs with CRLF
return $instr;
}

//----------------------------------------------------------------------------
//
// This function is used to echo information to the page as well as optionally log it to the TNG
// admin log.  The admin log is optional based upon a local variable in the function.
// A mod is used to optionally turn this off/on.
//
function logit($instr) {

// Optionally log this info to the admin log

	$logadmin = 1;
	
	echo $instr;
	if($logadmin == 1){
		adminwritelog(str_replace("<br>",",",$instr));
	}
return;
}